// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DLinePattern.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TD3DLinePattern 
//               Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DLinePattern.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DLinePattern*)
{
    new TD3DLinePattern(NULL);
}
// --------------------------------------------------------------------------
namespace Td3dlinepattern
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DLinePattern)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DLinePattern::TD3DLinePattern()
// Description: The default constructor for the TD3DLinePattern object.
// --------------------------------------------------------------------------
__fastcall TD3DLinePattern::TD3DLinePattern(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TD3DLinePattern::~TD3DLinePattern()
// Description: The destructor for the TD3DLinePattern object.
// --------------------------------------------------------------------------
__fastcall TD3DLinePattern::~TD3DLinePattern()
{
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DLinePattern method or 
//              fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DLinePattern::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLinePattern::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    LinePattern
// Description: The LinePattern property contains the bits that specify the 
//              line pattern. 
//              
//              Some simple line patterns examples may be: 
//              52428: 1100110011001100 to produce a dotted line. 
//              43690: 1010101010101010 to produce a point line. 
//              61166: 1110111011101110 to produce a dashed line. 
// --------------------------------------------------------------------------
word __fastcall TD3DLinePattern::FGetLinePattern()
{
return fD3DLINEPATTERN.wLinePattern;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLinePattern::FSetLinePattern( word pLinePattern )
{
fD3DLINEPATTERN.wLinePattern = pLinePattern;
}
// --------------------------------------------------------------------------
// Property:    RepeatFactor
// Description: The RepeatFactor property contains the number of times to 
//              duplicate each series of 1s and 0s specified in LinePattern. 
//              
//              This allows an application to stretch the line pattern if 
//              neccessary. 
//              D3DPMISCCAPS_LINEPATTERNREP must be present in 
//              TD3DPrimCaps::MiscCaps to set values greater than 1. 
// --------------------------------------------------------------------------
word __fastcall TD3DLinePattern::FGetRepeatFactor()
{
return fD3DLINEPATTERN.wRepeatFactor;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLinePattern::FSetRepeatFactor( word pRepeatFactor )
{
fD3DLINEPATTERN.wRepeatFactor = pRepeatFactor;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              D3DLINEPATTERN structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DLinePattern::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLinePattern::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DLinePattern's internal D3DLINEPATTERN structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DLinePattern::Clear()
{
fErrorValue = D3D_OK;
fD3DLINEPATTERN.wLinePattern = 0;
fD3DLINEPATTERN.wRepeatFactor = 0;
fSize = sizeof(D3DLINEPATTERN);
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
D3DLINEPATTERN* __fastcall TD3DLinePattern::FGetInternal_D3DLINEPATTERN_Ptr()
{
return &fD3DLINEPATTERN;
}
// --------------------------------------------------------------------------
void __fastcall TD3DLinePattern::FSetInternal_D3DLINEPATTERN( D3DLINEPATTERN* pD3DLINEPATTERN )
{
if (pD3DLINEPATTERN==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DLinePattern::FSetInternal_D3DLINEPATTERN()", "TDX_ERROR", "The supplied D3DLINEPATTERN* was NULL" );
    return;
    }

CopyMemory( &fD3DLINEPATTERN, pD3DLINEPATTERN, sizeof(D3DLINEPATTERN) );
Internal_D3DLINEPATTERN_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DLinePattern::Internal_D3DLINEPATTERN_Update()
{
}

// --------------------------------------------------------------------------
