// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DMaterial.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TD3DMaterial Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DMaterial.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DMaterial*)
{
    new TD3DMaterial(NULL);
}
// --------------------------------------------------------------------------
namespace Td3dmaterial
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DMaterial)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DMaterial::TD3DMaterial()
// Description: The default constructor for the TD3DMaterial object.
// --------------------------------------------------------------------------
__fastcall TD3DMaterial::TD3DMaterial(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
}
// --------------------------------------------------------------------------
// Destructor:  TD3DMaterial::~TD3DMaterial()
// Description: The destructor for the TD3DMaterial object.
// --------------------------------------------------------------------------
__fastcall TD3DMaterial::~TD3DMaterial()
{
}
// --------------------------------------------------------------------------
// Property:    Ambient
// Description: The Ambient property contains a TD3DColorValue component 
//              defining how the material reflects ambient lighting, thus 
//              helping determine the apparent color of the material. 
//              
//              This property is unioned with the ambient property of this 
//              component. 
//              Ambient values usually have less impact than Diffuse, due to 
//              most scenes having more diffuse lighting than ambient. 
// --------------------------------------------------------------------------
TD3DColorValue* __fastcall TD3DMaterial::FGetAmbient()
{
if (ComponentState.Contains(csDesigning) &&
    (fAmbient!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fAmbient)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fAmbient=NULL;
    }
return fAmbient;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::FSetAmbient( TD3DColorValue* pAmbient )
{
fAmbient = pAmbient;
}
// --------------------------------------------------------------------------
// Property:    Diffuse
// Description: The Diffuse property contains a TD3DColorValue component 
//              defining how the material reflects diffuse lighting, thus 
//              helping determine the apparent color of the material. 
//              
//              This property is unioned with the diffuse property of this 
//              component. 
//              Diffuse values usually have greater impact than Ambient, due 
//              to most scenes having more diffuse lighting than ambient. 
// --------------------------------------------------------------------------
TD3DColorValue* __fastcall TD3DMaterial::FGetDiffuse()
{
if (ComponentState.Contains(csDesigning) &&
    (fDiffuse!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fDiffuse)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fDiffuse=NULL;
    }
return fDiffuse;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::FSetDiffuse( TD3DColorValue* pDiffuse )
{
fDiffuse = pDiffuse;
}
// --------------------------------------------------------------------------
// Property:    Emissive
// Description: The Emissive property contains a TD3DColorValue component 
//              defining how the material emits, possibly making the material 
//              appear to glow independant of light sources. 
//              
//              This property is unioned with the emissive property of this 
//              component. 
//              Emitted light is not a computational light source and will 
//              not be reflected by other objects, only affecting the 
//              material itself. 
// --------------------------------------------------------------------------
TD3DColorValue* __fastcall TD3DMaterial::FGetEmissive()
{
if (ComponentState.Contains(csDesigning) &&
    (fEmissive!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fEmissive)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fEmissive=NULL;
    }
return fEmissive;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::FSetEmissive( TD3DColorValue* pEmissive )
{
fEmissive = pEmissive;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DMaterial method or fget/fset. 
//              eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DMaterial::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Power
// Description: The Power property contains a TD3DColorValue component 
//              defining the sharpness of the specular highlights the 
//              material reflects, in essence determining how shiny it looks 
//              under lighting. 
//              
//              This property is unioned with the power property of this 
//              component. 
//              Power defines the sharpness and Specular defines the color of 
//              the highlight. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMaterial::FGetPower()
{
return fD3DMATERIAL7.dvPower;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::FSetPower( D3DVALUE pPower )
{
fD3DMATERIAL7.dvPower = pPower;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of the internal 
//              D3DMATERIAL7 structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DMaterial::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Specular
// Description: The Specular property contains a TD3DColorValue component 
//              defining the color of the specular highlights the material 
//              reflects under lighting. 
//              
//              This property is unioned with the specular property of this 
//              component. 
//              Power defines the sharpness and Specular defines the color of 
//              the highlight. 
// --------------------------------------------------------------------------
TD3DColorValue* __fastcall TD3DMaterial::FGetSpecular()
{
if (ComponentState.Contains(csDesigning) &&
    (fSpecular!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fSpecular)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fSpecular=NULL;
    }
return fSpecular;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::FSetSpecular( TD3DColorValue* pSpecular )
{
fSpecular = pSpecular;
}
// --------------------------------------------------------------------------
// Property:    ambient
// Description: The ambient property contains a TD3DColorValue component 
//              defining how the material reflects ambient lighting, thus 
//              helping determine the apparent color of the material. 
//              
//              This property is unioned with the Ambient property of this 
//              compponent. 
//              Ambient values usually have less impact than Diffuse, due to 
//              most scenes having more diffuse lighting than ambient. 
// --------------------------------------------------------------------------
TD3DColorValue* __fastcall TD3DMaterial::FGetambient()
{
if (ComponentState.Contains(csDesigning) &&
    (fambient!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fambient)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fambient=NULL;
    }
return fambient;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::FSetambient( TD3DColorValue* pambient )
{
fambient = pambient;
}
// --------------------------------------------------------------------------
// Property:    diffuse
// Description: The diffuse property contains a TD3DColorValue component 
//              defining how the material reflects diffuse lighting, thus 
//              helping determine the apparent color of the material. 
//              
//              This property is unioned with the Diffuse property of this 
//              component. 
//              Diffuse values usually have greater impact than Ambient, due 
//              to most scenes having more diffuse lighting than ambient. 
// --------------------------------------------------------------------------
TD3DColorValue* __fastcall TD3DMaterial::FGetdiffuse()
{
if (ComponentState.Contains(csDesigning) &&
    (fdiffuse!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fdiffuse)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fdiffuse=NULL;
    }
return fdiffuse;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::FSetdiffuse( TD3DColorValue* pdiffuse )
{
fdiffuse = pdiffuse;
}
// --------------------------------------------------------------------------
// Property:    emissive
// Description: The emissive property contains a TD3DColorValue component 
//              defining how the material emits, possibly making the material 
//              appear to glow independant of light sources. 
//              
//              This property is unioned with the Emissive property of this 
//              component. 
//              Emitted light is not a computational light source and will 
//              not be reflected by other objects, only affecting the 
//              material itself. 
// --------------------------------------------------------------------------
TD3DColorValue* __fastcall TD3DMaterial::FGetemissive()
{
if (ComponentState.Contains(csDesigning) &&
    (femissive!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==femissive)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) femissive=NULL;
    }
return femissive;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::FSetemissive( TD3DColorValue* pemissive )
{
femissive = pemissive;
}
// --------------------------------------------------------------------------
// Property:    power
// Description: The power property contains a TD3DColorValue component 
//              defining the sharpness of the specular highlights the 
//              material reflects, in essence determining how shiny it looks 
//              under lighting. 
//              
//              This property is unioned with the Power property of this 
//              component. 
//              Power defines the sharpness and Specular defines the color of 
//              the highlight. 
// --------------------------------------------------------------------------
D3DVALUE __fastcall TD3DMaterial::FGetpower()
{
return fD3DMATERIAL7.power;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::FSetpower( D3DVALUE ppower )
{
fD3DMATERIAL7.power = ppower;
}
// --------------------------------------------------------------------------
// Property:    specular
// Description: The specular property contains a TD3DColorValue component 
//              defining the color of the specular highlights the material 
//              reflects under lighting. 
//              
//              This property is unioned with the Specular property of this 
//              component. 
//              Power defines the sharpness and Specular defines the color of 
//              the highlight. 
// --------------------------------------------------------------------------
TD3DColorValue* __fastcall TD3DMaterial::FGetspecular()
{
if (ComponentState.Contains(csDesigning) &&
    (fspecular!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fspecular)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fspecular=NULL;
    }
return fspecular;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::FSetspecular( TD3DColorValue* pspecular )
{
fspecular = pspecular;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DMaterial's internal D3DMATERIAL7 structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::Clear()
{
fAmbient = NULL;
fDiffuse = NULL;
fEmissive = NULL;
fErrorValue = D3D_OK;
fSize = sizeof(D3DMATERIAL7);
fSpecular = NULL;
fambient = NULL;
fdiffuse = NULL;
femissive = NULL;
fspecular = NULL;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
D3DMATERIAL7* __fastcall TD3DMaterial::FGetInternal_D3DMATERIAL7_Ptr()
{
if (fAmbient!=NULL) CopyMemory( &fD3DMATERIAL7.dcvAmbient, fAmbient->Internal_D3DCOLORVALUE_Ptr, sizeof(D3DCOLORVALUE) );
if (fDiffuse!=NULL) CopyMemory( &fD3DMATERIAL7.dcvDiffuse, fDiffuse->Internal_D3DCOLORVALUE_Ptr, sizeof(D3DCOLORVALUE) );
if (fEmissive!=NULL) CopyMemory( &fD3DMATERIAL7.dcvEmissive, fEmissive->Internal_D3DCOLORVALUE_Ptr, sizeof(D3DCOLORVALUE) );
if (fSpecular!=NULL) CopyMemory( &fD3DMATERIAL7.dcvSpecular, fSpecular->Internal_D3DCOLORVALUE_Ptr, sizeof(D3DCOLORVALUE) );
if (fambient!=NULL) CopyMemory( &fD3DMATERIAL7.ambient, fambient->Internal_D3DCOLORVALUE_Ptr, sizeof(D3DCOLORVALUE) );
if (fdiffuse!=NULL) CopyMemory( &fD3DMATERIAL7.diffuse, fdiffuse->Internal_D3DCOLORVALUE_Ptr, sizeof(D3DCOLORVALUE) );
if (femissive!=NULL) CopyMemory( &fD3DMATERIAL7.emissive, femissive->Internal_D3DCOLORVALUE_Ptr, sizeof(D3DCOLORVALUE) );
if (fspecular!=NULL) CopyMemory( &fD3DMATERIAL7.specular, fspecular->Internal_D3DCOLORVALUE_Ptr, sizeof(D3DCOLORVALUE) );
return &fD3DMATERIAL7;
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::FSetInternal_D3DMATERIAL7( D3DMATERIAL7* pD3DMATERIAL7 )
{
if (pD3DMATERIAL7==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DMaterial::FSetInternal_D3DMATERIAL7()", "TDX_ERROR", "The supplied D3DMATERIAL7* was NULL" );
    return;
    }

CopyMemory( &fD3DMATERIAL7, pD3DMATERIAL7, sizeof(D3DMATERIAL7) );
Internal_D3DMATERIAL7_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DMaterial::Internal_D3DMATERIAL7_Update()
{
if (fAmbient!=NULL) CopyMemory( fAmbient->Internal_D3DCOLORVALUE_Ptr, &fD3DMATERIAL7.dcvAmbient, sizeof(D3DCOLORVALUE) );
if (fDiffuse!=NULL) CopyMemory( fDiffuse->Internal_D3DCOLORVALUE_Ptr, &fD3DMATERIAL7.dcvDiffuse, sizeof(D3DCOLORVALUE) );
if (fEmissive!=NULL) CopyMemory( fEmissive->Internal_D3DCOLORVALUE_Ptr, &fD3DMATERIAL7.dcvEmissive, sizeof(D3DCOLORVALUE) );
if (fSpecular!=NULL) CopyMemory( fSpecular->Internal_D3DCOLORVALUE_Ptr, &fD3DMATERIAL7.dcvSpecular, sizeof(D3DCOLORVALUE) );
if (fambient!=NULL) CopyMemory( fambient->Internal_D3DCOLORVALUE_Ptr, &fD3DMATERIAL7.ambient, sizeof(D3DCOLORVALUE) );
if (fdiffuse!=NULL) CopyMemory( fdiffuse->Internal_D3DCOLORVALUE_Ptr, &fD3DMATERIAL7.diffuse, sizeof(D3DCOLORVALUE) );
if (femissive!=NULL) CopyMemory( femissive->Internal_D3DCOLORVALUE_Ptr, &fD3DMATERIAL7.emissive, sizeof(D3DCOLORVALUE) );
if (fspecular!=NULL) CopyMemory( fspecular->Internal_D3DCOLORVALUE_Ptr, &fD3DMATERIAL7.specular, sizeof(D3DCOLORVALUE) );
}

// --------------------------------------------------------------------------
