// --------------------------------------------------------------------------

// ==========================================================================
// File:         TD3DRect.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TD3DRect Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TD3DRect.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TD3DRect*)
{
    new TD3DRect(NULL);
}
// --------------------------------------------------------------------------
namespace Td3drect
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TD3DRect)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TD3DRect::TD3DRect()
// Description: The default constructor for the TD3DRect object.
// --------------------------------------------------------------------------
__fastcall TD3DRect::TD3DRect(TComponent* Owner)
    : TComponent(Owner)
{
fD3DRECT=NULL;
fArraySize=0;
ArraySize=1;
ClearAll();
}
// --------------------------------------------------------------------------
// Destructor:  TD3DRect::~TD3DRect()
// Description: The destructor for the TD3DRect object.
// --------------------------------------------------------------------------
__fastcall TD3DRect::~TD3DRect()
{
// destroy internals
if (ArraySize!=0) ArraySize = 0;
}
// --------------------------------------------------------------------------
// Property:    ArraySize
// Description: The ArraySize property contains the number of internal 
//              D3DRECT structures wrapped inside the TD3DRect component. 
//              By default the ArraySize is initialized to 1, meaning that 
//              this TD3DRect component wraps a single D3DRECT structure. To 
//              wrap multiple structures, set the TD3DRect::ArraySize to the 
//              total number of internal structures desired. 
// --------------------------------------------------------------------------
dword __fastcall TD3DRect::FGetArraySize()
{
return fArraySize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DRect::FSetArraySize( dword pArraySize )
{
// check for size==0
if (pArraySize==0)
    {
    // de-allocate old memory
    delete[] fD3DRECT;
    fD3DRECT = NULL;
    fArraySize = 0;
    return;
    }

// is anything allocated?
if (fArraySize==0)
    {
    // nope. need to allocate memory for pointers to internal structures
    fD3DRECT = new D3DRECT[pArraySize];
    if (fD3DRECT==NULL)
        {
        fArraySize = 0;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TD3DRECT::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal D3DRECT structure pointers.");
        return;
        }
    // setup defaults
    fArraySize = pArraySize;
    ClearAll();
    }
else
    // already allocated... has the size increased?
    if (pArraySize>fArraySize)
        {
        // allocate space for the new structures
        D3DRECT* temp_D3DRECT = new D3DRECT[pArraySize];
        if (temp_D3DRECT==NULL)
            {
            fErrorValue = TDX_ERROR;
            if (FOnError) FOnError(this, "TD3DRECT::FSetArraySize()", "TDX_ERROR", "Could not allocate extra memory for storing internal D3DRECT structures.");
            return;
            }
        // clear new data areas
        ZeroMemory( &temp_D3DRECT[fArraySize], sizeof(D3DRECT)*(pArraySize-fArraySize) );
        // duplicate existing data
        CopyMemory( &temp_D3DRECT[0], &fD3DRECT[0], sizeof(D3DRECT)*fArraySize);
        // de-allocate old memory
        delete[] fD3DRECT;
        // re-assign the new memory
        fD3DRECT = temp_D3DRECT;
        // store new array size
        fArraySize = pArraySize;
        }
    else
        // already allocated... has the size reduced?
        if (pArraySize<fArraySize)
            {
            // allocate space for the new structures
            D3DRECT* temp_D3DRECT = new D3DRECT[pArraySize];
            if (temp_D3DRECT==NULL)
                {
                fErrorValue = TDX_ERROR;
                if (FOnError) FOnError(this, "TD3DRECT::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal D3DRECT structures.");
                return;
                }
            // duplicate existing data
            CopyMemory( &temp_D3DRECT[0], &fD3DRECT[0], sizeof(D3DRECT)*pArraySize);
            // de-allocate the old memory
            delete[] fD3DRECT;
            // re-assign the new memory
            fD3DRECT = temp_D3DRECT;
            // store new array size
            fArraySize = pArraySize;
            }
// else - size is the same.
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TD3DRect method or fget/fset. eg. 
//              D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TD3DRect::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TD3DRect::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property contains the size in bytes of a single 
//              internal D3DRECT structure. 
// --------------------------------------------------------------------------
dword __fastcall TD3DRect::FGetSize()
{
return fSize;
}
// --------------------------------------------------------------------------
void __fastcall TD3DRect::FSetSize( dword pSize )
{
fSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SizeAll
// Description: The SizeAll property contains the size in bytes of all 
//              internal D3DRECT structures. This result is the same as 
//              multiplying TD3DRect::ArraySize and TD3DRect::Size. 
// --------------------------------------------------------------------------
dword __fastcall TD3DRect::FGetSizeAll()
{
return fArraySize * fSize;
}
// --------------------------------------------------------------------------
// Property:    X1
// Description: The X1 property contains the X coordinate of the upper left 
//              corner of the rectangle. 
//              
//              This property is unioned with the x1 property of this 
//              component. 
// --------------------------------------------------------------------------
long __fastcall TD3DRect::FGetX1( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGetX1()", "TDX_ERROR", "Internal Array size is 0.");
     return (long) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGetX1()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (long) NULL;
    }

return fD3DRECT[pArrayIndex].lX1;
}
// --------------------------------------------------------------------------
void __fastcall TD3DRect::FSetX1( dword pArrayIndex, long pX1 )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSetX1()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSetX1()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DRECT[pArrayIndex].lX1 = pX1;
}
// --------------------------------------------------------------------------
// Property:    X2
// Description: The X2 property contains the X coordinate of the lower right 
//              corner of the rectangle. 
//              
//              This property is unioned with the x2 property of this 
//              component. 
// --------------------------------------------------------------------------
long __fastcall TD3DRect::FGetX2( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGetX2()", "TDX_ERROR", "Internal Array size is 0.");
     return (long) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGetX2()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (long) NULL;
    }

return fD3DRECT[pArrayIndex].lX2;
}
// --------------------------------------------------------------------------
void __fastcall TD3DRect::FSetX2( dword pArrayIndex, long pX2 )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSetX2()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSetX2()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DRECT[pArrayIndex].lX2 = pX2;
}
// --------------------------------------------------------------------------
// Property:    Y1
// Description: The Y1 property contains the Y coordinate of the upper left 
//              corner of the rectangle. 
//              
//              This property is unioned with the y1 property of this 
//              component. 
// --------------------------------------------------------------------------
long __fastcall TD3DRect::FGetY1( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGetY1()", "TDX_ERROR", "Internal Array size is 0.");
     return (long) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGetY1()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (long) NULL;
    }

return fD3DRECT[pArrayIndex].lY1;
}
// --------------------------------------------------------------------------
void __fastcall TD3DRect::FSetY1( dword pArrayIndex, long pY1 )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSetY1()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSetY1()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DRECT[pArrayIndex].lY1 = pY1;
}
// --------------------------------------------------------------------------
// Property:    Y2
// Description: The Y2 property contains the Y coordinate of the lower right 
//              corner of the rectangle. 
//              
//              This property is unioned with the y2 property of this 
//              component. 
// --------------------------------------------------------------------------
long __fastcall TD3DRect::FGetY2( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGetY2()", "TDX_ERROR", "Internal Array size is 0.");
     return (long) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGetY2()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (long) NULL;
    }

return fD3DRECT[pArrayIndex].lY2;
}
// --------------------------------------------------------------------------
void __fastcall TD3DRect::FSetY2( dword pArrayIndex, long pY2 )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSetY2()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSetY2()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DRECT[pArrayIndex].lY2 = pY2;
}
// --------------------------------------------------------------------------
// Property:    x1
// Description: The x1 property contains the X coordinate of the upper left 
//              corner of the rectangle. 
//              
//              This property is unioned with the X1 property of this 
//              component. 
// --------------------------------------------------------------------------
long __fastcall TD3DRect::FGetx1( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGetx1()", "TDX_ERROR", "Internal Array size is 0.");
     return (long) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGetx1()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (long) NULL;
    }

return fD3DRECT[pArrayIndex].x1;
}
// --------------------------------------------------------------------------
void __fastcall TD3DRect::FSetx1( dword pArrayIndex, long px1 )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSetx1()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSetx1()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DRECT[pArrayIndex].x1 = px1;
}
// --------------------------------------------------------------------------
// Property:    x2
// Description: The x2 property contains the X coordinate of the lower right 
//              corner of the rectangle. 
//              
//              This property is unioned with the X2 property of this 
//              component. 
// --------------------------------------------------------------------------
long __fastcall TD3DRect::FGetx2( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGetx2()", "TDX_ERROR", "Internal Array size is 0.");
     return (long) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGetx2()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (long) NULL;
    }

return fD3DRECT[pArrayIndex].x2;
}
// --------------------------------------------------------------------------
void __fastcall TD3DRect::FSetx2( dword pArrayIndex, long px2 )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSetx2()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSetx2()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DRECT[pArrayIndex].x2 = px2;
}
// --------------------------------------------------------------------------
// Property:    y1
// Description: The y1 property contains the Y coordinate of the upper left 
//              corner of the rectangle. 
//              
//              This property is unioned with the Y1 property of this 
//              component. 
// --------------------------------------------------------------------------
long __fastcall TD3DRect::FGety1( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGety1()", "TDX_ERROR", "Internal Array size is 0.");
     return (long) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGety1()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (long) NULL;
    }

return fD3DRECT[pArrayIndex].y1;
}
// --------------------------------------------------------------------------
void __fastcall TD3DRect::FSety1( dword pArrayIndex, long py1 )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSety1()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSety1()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DRECT[pArrayIndex].y1 = py1;
}
// --------------------------------------------------------------------------
// Property:    y2
// Description: The y2 property contains the Y coordinate of the lower right 
//              corner of the rectangle. 
//              
//              This property is unioned with the Y2 property of this 
//              component. 
// --------------------------------------------------------------------------
long __fastcall TD3DRect::FGety2( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGety2()", "TDX_ERROR", "Internal Array size is 0.");
     return (long) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FGety2()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (long) NULL;
    }

return fD3DRECT[pArrayIndex].y2;
}
// --------------------------------------------------------------------------
void __fastcall TD3DRect::FSety2( dword pArrayIndex, long py2 )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSety2()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::FSety2()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fD3DRECT[pArrayIndex].y2 = py2;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TD3DRect's internal D3DRECT structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// Params:      pArrayIndex - 
//                The ArrayIndex parameter determines which internal structure 
//                needs to be cleared. Correct values range from 0 to 
//                TD3DRect::ArraySize-1. 
// --------------------------------------------------------------------------
void __fastcall TD3DRect::Clear( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::Clear()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

ZeroMemory( &fD3DRECT[pArrayIndex], sizeof(D3DRECT) );
}


// --------------------------------------------------------------------------
// Method:      ClearAll()
// Description: The ClearAll() method can be used to clear the contents of 
//              all the internal D3DRECT structures of the TD3DRect 
//              component. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TD3DRect::ClearAll()
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TD3DRect::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }

ZeroMemory( &fD3DRECT[0], sizeof(D3DRECT)*fArraySize );
}


// --------------------------------------------------------------------------
// Internal Structure Access 
// --------------------------------------------------------------------------
D3DRECT* __fastcall TD3DRect::FGetInternal_D3DRECT_Ptr()
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DRect::FGetInternal_D3DRECT_Ptr()", "TDX_ERROR", "Internal Array size is 0." );
    return NULL;
    }
return fD3DRECT;
}
// --------------------------------------------------------------------------
void __fastcall TD3DRect::FSetInternal_D3DRECT( dword pArrayIndex, D3DRECT* pD3DRECT )
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DRect::FSetInternal_D3DRECT()", "TDX_ERROR", "Internal Array size is 0." );
    return;
    }
if (pD3DRECT==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TD3DRect::FSetInternal_D3DRECT()", "TDX_ERROR", "The supplied D3DRECT* was NULL" );
    return;
    }
CopyMemory( &fD3DRECT[pArrayIndex], pD3DRECT, sizeof(D3DRECT) );
Internal_D3DRECT_Update();
}
// --------------------------------------------------------------------------
void __fastcall TD3DRect::Internal_D3DRECT_Update()
{
}

// --------------------------------------------------------------------------
