// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDDSurfaceDesc.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDDSurfaceDesc Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDDSurfaceDesc.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDDSurfaceDesc*)
{
    new TDDSurfaceDesc(NULL);
}
// --------------------------------------------------------------------------
namespace Tddsurfacedesc
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDDSurfaceDesc)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDDSurfaceDesc::TDDSurfaceDesc()
// Description: The default constructor for the TDDSurfaceDesc object.
// --------------------------------------------------------------------------
__fastcall TDDSurfaceDesc::TDDSurfaceDesc(TComponent* Owner)
    : TComponent(Owner)
{
Clear();
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDDSurfaceDesc::~TDDSurfaceDesc()
// Description: The destructor for the TDDSurfaceDesc object.
// --------------------------------------------------------------------------
__fastcall TDDSurfaceDesc::~TDDSurfaceDesc()
{
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    AlphaBitDepth
// Description: The AlphaBitDepth property defines the bit depth of the alpha 
//              channel. 
// --------------------------------------------------------------------------
dword __fastcall TDDSurfaceDesc::FGetAlphaBitDepth()
{
return fDDSURFACEDESC2.dwAlphaBitDepth;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetAlphaBitDepth( dword pAlphaBitDepth )
{
fDDSURFACEDESC2.dwAlphaBitDepth = pAlphaBitDepth;
}
// --------------------------------------------------------------------------
// Property:    BackBufferCount
// Description: The BackBufferCount property defines the number of back 
//              buffers associated with the surface. 
// --------------------------------------------------------------------------
dword __fastcall TDDSurfaceDesc::FGetBackBufferCount()
{
return fDDSURFACEDESC2.dwBackBufferCount;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetBackBufferCount( dword pBackBufferCount )
{
fDDSURFACEDESC2.dwBackBufferCount = pBackBufferCount;
}
// --------------------------------------------------------------------------
// Property:    CKDestBlt
// Description: The CKDestBlt property references the destination color key 
//              for blit operations. 
// --------------------------------------------------------------------------
TDDColorKey* __fastcall TDDSurfaceDesc::FGetCKDestBlt()
{
if (ComponentState.Contains(csDesigning) &&
    (fCKDestBlt!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fCKDestBlt)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fCKDestBlt=NULL;
    }
return fCKDestBlt;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetCKDestBlt( TDDColorKey* pCKDestBlt )
{
fCKDestBlt = pCKDestBlt;
}
// --------------------------------------------------------------------------
// Property:    CKDestOverlay
// Description: The CKDestOverlay property references the destination color 
//              key for overlay operations. 
// --------------------------------------------------------------------------
TDDColorKey* __fastcall TDDSurfaceDesc::FGetCKDestOverlay()
{
if (ComponentState.Contains(csDesigning) &&
    (fCKDestOverlay!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fCKDestOverlay)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fCKDestOverlay=NULL;
    }
return fCKDestOverlay;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetCKDestOverlay( TDDColorKey* pCKDestOverlay )
{
fCKDestOverlay = pCKDestOverlay;
}
// --------------------------------------------------------------------------
// Property:    CKSrcBlt
// Description: The CKSrcBlt property references the source color key for 
//              blit operations. 
// --------------------------------------------------------------------------
TDDColorKey* __fastcall TDDSurfaceDesc::FGetCKSrcBlt()
{
if (ComponentState.Contains(csDesigning) &&
    (fCKSrcBlt!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fCKSrcBlt)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fCKSrcBlt=NULL;
    }
return fCKSrcBlt;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetCKSrcBlt( TDDColorKey* pCKSrcBlt )
{
fCKSrcBlt = pCKSrcBlt;
}
// --------------------------------------------------------------------------
// Property:    CKSrcOverlay
// Description: The CKSrcOverlay property references the source color key for 
//              overlay operations. 
// --------------------------------------------------------------------------
TDDColorKey* __fastcall TDDSurfaceDesc::FGetCKSrcOverlay()
{
if (ComponentState.Contains(csDesigning) &&
    (fCKSrcOverlay!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fCKSrcOverlay)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fCKSrcOverlay=NULL;
    }
return fCKSrcOverlay;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetCKSrcOverlay( TDDColorKey* pCKSrcOverlay )
{
fCKSrcOverlay = pCKSrcOverlay;
}
// --------------------------------------------------------------------------
// Property:    EmptyFaceColor
// Description: Defines the color used to fill in cube map faces that have 
//              not had a texture assigned to them. 
// --------------------------------------------------------------------------
dword __fastcall TDDSurfaceDesc::FGetEmptyFaceColor()
{
return fDDSURFACEDESC2.dwEmptyFaceColor;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetEmptyFaceColor( dword pEmptyFaceColor )
{
fDDSURFACEDESC2.dwEmptyFaceColor = pEmptyFaceColor;
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDDSurfaceDesc method or fget/fset. 
//              eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDDSurfaceDesc::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags indicating which properties 
//              of this component contain valid data. 
//              The described effect applies when the flag is set. 
// Flags:       DDSD_ALL -
//                All properties of this component contain valid data. 
//              DDSD_ALPHABITDEPTH -
//                TDDSurfaceDesc::AlphaBitDepth contains valid data. 
//              DDSD_BACKBUFFERCOUNT -
//                TDDSurfaceDesc::BackBufferCount contains valid data. 
//              DDSD_CAPS -
//                TDDSurfaceDesc::SCaps contains valid data. 
//              DDSD_CKDESTBLT -
//                TDDSurfaceDesc::CKDestBlt contains valid data. 
//              DDSD_CKDESTOVERLAY -
//                TDDSurfaceDesc::CKDestOverlay contains valid data. 
//              DDSD_CKSRCBLT -
//                TDDSurfaceDesc::CKSrcBlt contains valid data. 
//              DDSD_CKSRCOVERLAY -
//                TDDSurfaceDesc::CKSrcOverlay contains valid data. 
//              DDSD_HEIGHT -
//                TDDSurfaceDesc::Height contains valid data. 
//              DDSD_LINEARSIZE -
//                TDDSurfaceDesc::LinearSize contains valid data. 
//              DDSD_LPSURFACE -
//                TDDSurfaceDesc::Surface contains valid data. 
//              DDSD_MIPMAPCOUNT -
//                TDDSurfaceDesc::MipMapCount contains valid data. 
//              DDSD_PITCH -
//                TDDSurfaceDesc::Pitch contains valid data. 
//              DDSD_PIXELFORMAT -
//                TDDSurfaceDesc::PixelFormat contains valid data. 
//              DDSD_REFRESHRATE -
//                TDDSurfaceDesc::RefreshRate contains valid data. 
//              DDSD_TEXTURESTAGE -
//                TDDSurfaceDesc::TextureStage contains valid data. 
//              DDSD_WIDTH -
//                TDDSurfaceDesc::Width contains valid data. 
// --------------------------------------------------------------------------
dword __fastcall TDDSurfaceDesc::FGetFlags()
{
return fDDSURFACEDESC2.dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetFlags( dword pFlags )
{
fDDSURFACEDESC2.dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    Height
// Description: The Height property defines the vertical dimension, in 
//              pixels, of the surface being described. 
// --------------------------------------------------------------------------
dword __fastcall TDDSurfaceDesc::FGetHeight()
{
return fDDSURFACEDESC2.dwHeight;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetHeight( dword pHeight )
{
fDDSURFACEDESC2.dwHeight = pHeight;
}
// --------------------------------------------------------------------------
// Property:    LinearSize
// Description: The LinearSize property defines the buffer size. 
//              Currently only used for compressed texture surfaces. 
// --------------------------------------------------------------------------
dword __fastcall TDDSurfaceDesc::FGetLinearSize()
{
return fDDSURFACEDESC2.dwLinearSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetLinearSize( dword pLinearSize )
{
fDDSURFACEDESC2.dwLinearSize = pLinearSize;
}
// --------------------------------------------------------------------------
// Property:    MipMapCount
// Description: The MipMapCount property defines the number of mipmap levels. 
// --------------------------------------------------------------------------
dword __fastcall TDDSurfaceDesc::FGetMipMapCount()
{
return fDDSURFACEDESC2.dwMipMapCount;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetMipMapCount( dword pMipMapCount )
{
fDDSURFACEDESC2.dwMipMapCount = pMipMapCount;
}
// --------------------------------------------------------------------------
// Property:    Pitch
// Description: The Pitch property defines the distance, in bytes, between 
//              the start of one bitmap line and the start of the next. 
//              For TDx_DrawSurface::GetSurfaceDesc(), this is a return 
//              value. 
//              For TDx_DrawSurface::SetSurfaceDesc(), this is an input value 
//              that must be a dword multiple. 
// --------------------------------------------------------------------------
long __fastcall TDDSurfaceDesc::FGetPitch()
{
return fDDSURFACEDESC2.lPitch;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetPitch( long pPitch )
{
fDDSURFACEDESC2.lPitch = pPitch;
}
// --------------------------------------------------------------------------
// Property:    PixelFormat
// Description: The PixelFormat property references a TDDPixelFormat 
//              component describing the surface's pixel format. 
// --------------------------------------------------------------------------
TDDPixelFormat* __fastcall TDDSurfaceDesc::FGetPixelFormat()
{
if (ComponentState.Contains(csDesigning) &&
    (fPixelFormat!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fPixelFormat)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fPixelFormat=NULL;
    }
return fPixelFormat;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetPixelFormat( TDDPixelFormat* pPixelFormat )
{
fPixelFormat = pPixelFormat;
}
// --------------------------------------------------------------------------
// Property:    RefreshRate
// Description: The RefreshRate property defines the refresh rate of the 
//              current display mode. 
//              A value of 0 indicates an adapter fault. 
// --------------------------------------------------------------------------
dword __fastcall TDDSurfaceDesc::FGetRefreshRate()
{
return fDDSURFACEDESC2.dwRefreshRate;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetRefreshRate( dword pRefreshRate )
{
fDDSURFACEDESC2.dwRefreshRate = pRefreshRate;
}
// --------------------------------------------------------------------------
// Property:    SCaps
// Description: The SCaps property references a TDDSCaps component defining 
//              the capabilities of the surface. 
// --------------------------------------------------------------------------
TDDSCaps* __fastcall TDDSurfaceDesc::FGetSCaps()
{
if (ComponentState.Contains(csDesigning) &&
    (fSCaps!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fSCaps)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fSCaps=NULL;
    }
return fSCaps;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetSCaps( TDDSCaps* pSCaps )
{
fSCaps = pSCaps;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDDSurfaceDesc::FGetSize()
{
return fDDSURFACEDESC2.dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetSize( dword pSize )
{
fDDSURFACEDESC2.dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    Surface
// Description: The Surface property references the memory associated with 
//              the surface this component describes. 
//              For TDx_DrawSurface::Lock(), this should be a valid pointer 
//              to surface memory. 
//              For TDx_DrawSurface::SetSurfaceDesc(), this should be a 
//              pointer to system memory explicitly allocated for the surface 
//              by the calling application. 
// --------------------------------------------------------------------------
TDx_DrawSurface* __fastcall TDDSurfaceDesc::FGetSurface()
{
if (ComponentState.Contains(csDesigning) &&
    (fSurface!=NULL) &&
    (Owner!=NULL))
    {
    bool component_exists = false;
    for (int i=0;i<Owner->ComponentCount;i++)
        if (Owner->Components[i]==fSurface)
            {
            component_exists = true;
            break;
            }
    if (!component_exists) fSurface=NULL;
    }
return fSurface;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetSurface( TDx_DrawSurface* pSurface )
{
if (fSurface!=NULL)
    {
    fDDSURFACEDESC2.lpSurface = (LPDIRECTDRAWSURFACE) fSurface->Internal_LPDIRECTDRAWSURFACE7;
    }
}
// --------------------------------------------------------------------------
// Property:    TextureStage
// Description: The TextureStage property defines the stage identifier which 
//              binds the texture surface described by this component to a 
//              specific stage of a 3D device's multitexture cascade. 
//              This setting is reccomended for most 3D hardware. 
// --------------------------------------------------------------------------
dword __fastcall TDDSurfaceDesc::FGetTextureStage()
{
return fDDSURFACEDESC2.dwTextureStage;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetTextureStage( dword pTextureStage )
{
fDDSURFACEDESC2.dwTextureStage = pTextureStage;
}
// --------------------------------------------------------------------------
// Property:    Width
// Description: The Width property defines the horizontal dimension, in 
//              pixels, of the surface being described. 
// --------------------------------------------------------------------------
dword __fastcall TDDSurfaceDesc::FGetWidth()
{
return fDDSURFACEDESC2.dwWidth;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetWidth( dword pWidth )
{
fDDSURFACEDESC2.dwWidth = pWidth;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDDSurfaceDesc's internal DDSURFACEDESC2 structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::Clear()
{
fDDSURFACEDESC2.dwAlphaBitDepth = 0;
fDDSURFACEDESC2.dwBackBufferCount = 0;
fCKDestBlt = NULL;
fCKDestOverlay = NULL;
fCKSrcBlt = NULL;
fCKSrcOverlay = NULL;
fDDSURFACEDESC2.dwEmptyFaceColor = 0;
fErrorValue = D3D_OK;
fDDSURFACEDESC2.dwFlags = 0;
fDDSURFACEDESC2.dwHeight = 0;
fDDSURFACEDESC2.dwLinearSize = 0;
fDDSURFACEDESC2.dwMipMapCount = 0;
fDDSURFACEDESC2.lPitch = 0;
fPixelFormat = NULL;
fDDSURFACEDESC2.dwRefreshRate = 0;
fSCaps = NULL;
fDDSURFACEDESC2.dwSize = sizeof(DDSURFACEDESC2);
fSurface = NULL;
fDDSURFACEDESC2.dwTextureStage = 0;
fDDSURFACEDESC2.dwWidth = 0;
}

// --------------------------------------------------------------------------
// Internal Structure Access
// --------------------------------------------------------------------------
DDSURFACEDESC2* __fastcall TDDSurfaceDesc::FGetInternal_DDSURFACEDESC2_Ptr()
{
if (fCKDestBlt!=NULL) CopyMemory( &fDDSURFACEDESC2.ddckCKDestBlt, fCKDestBlt->Internal_DDCOLORKEY_Ptr, sizeof(DDCOLORKEY) );
if (fCKDestOverlay!=NULL) CopyMemory( &fDDSURFACEDESC2.ddckCKDestOverlay, fCKDestOverlay->Internal_DDCOLORKEY_Ptr, sizeof(DDCOLORKEY) );
if (fCKSrcBlt!=NULL) CopyMemory( &fDDSURFACEDESC2.ddckCKSrcBlt, fCKSrcBlt->Internal_DDCOLORKEY_Ptr, sizeof(DDCOLORKEY) );
if (fCKSrcOverlay!=NULL) CopyMemory( &fDDSURFACEDESC2.ddckCKSrcOverlay, fCKSrcOverlay->Internal_DDCOLORKEY_Ptr, sizeof(DDCOLORKEY) );
if (fPixelFormat!=NULL)
    if (fPixelFormat->ArraySize>0) CopyMemory( &fDDSURFACEDESC2.ddpfPixelFormat, fPixelFormat->Internal_DDPIXELFORMAT_Ptr, sizeof(DDPIXELFORMAT) );
    else ZeroMemory( &fDDSURFACEDESC2.ddpfPixelFormat, sizeof(DDPIXELFORMAT) );
if (fSCaps!=NULL) CopyMemory( &fDDSURFACEDESC2.ddsCaps, fSCaps->Internal_DDSCAPS2_Ptr, sizeof(DDSCAPS2) );
return &fDDSURFACEDESC2;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetInternal_DDSURFACEDESC2( DDSURFACEDESC2* pDDSURFACEDESC2 )
{
if (pDDSURFACEDESC2==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDSurfaceDesc::FSetInternal_DDSURFACEDESC2()", "TDX_ERROR", "The supplied DDSURFACEDESC2* was NULL" );
    return;
    }

CopyMemory( &fDDSURFACEDESC2, pDDSURFACEDESC2, sizeof(DDSURFACEDESC2) );
Internal_DDSURFACEDESC2_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::Internal_DDSURFACEDESC2_Update()
{
if (fCKDestBlt!=NULL) CopyMemory( fCKDestBlt->Internal_DDCOLORKEY_Ptr, &fDDSURFACEDESC2.ddckCKDestBlt, sizeof(DDCOLORKEY) );
if (fCKDestOverlay!=NULL) CopyMemory( fCKDestOverlay->Internal_DDCOLORKEY_Ptr, &fDDSURFACEDESC2.ddckCKDestOverlay, sizeof(DDCOLORKEY) );
if (fCKSrcBlt!=NULL) CopyMemory( fCKSrcBlt->Internal_DDCOLORKEY_Ptr, &fDDSURFACEDESC2.ddckCKSrcBlt, sizeof(DDCOLORKEY) );
if (fCKSrcOverlay!=NULL) CopyMemory( fCKSrcOverlay->Internal_DDCOLORKEY_Ptr, &fDDSURFACEDESC2.ddckCKSrcOverlay, sizeof(DDCOLORKEY) );
if (fPixelFormat!=NULL)
    if (fPixelFormat->ArraySize>0) CopyMemory( fPixelFormat->Internal_DDPIXELFORMAT_Ptr, &fDDSURFACEDESC2.ddpfPixelFormat, sizeof(DDPIXELFORMAT) );
if (fSCaps!=NULL) CopyMemory( fSCaps->Internal_DDSCAPS2_Ptr, &fDDSURFACEDESC2.ddsCaps, sizeof(DDSCAPS2) );
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDDSurfaceDesc_Flags_Set<> of the flags 
//              in the current fDDSURFACEDESC2.dwFlags. 
// Note:        Wrapper components use the following method to modify flags 
//              via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDDSurfaceDesc_Flags_Set __fastcall TDDSurfaceDesc::FGetFlags_()
{
TDDSurfaceDesc_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDDSURFACEDESC2.dwFlags & DDSD_ALPHABITDEPTH) TempFlags_ = TempFlags_ << ddsd_alphabitdepth;
if (fDDSURFACEDESC2.dwFlags & DDSD_BACKBUFFERCOUNT) TempFlags_ = TempFlags_ << ddsd_backbuffercount;
if (fDDSURFACEDESC2.dwFlags & DDSD_CAPS) TempFlags_ = TempFlags_ << ddsd_caps;
if (fDDSURFACEDESC2.dwFlags & DDSD_CKDESTBLT) TempFlags_ = TempFlags_ << ddsd_ckdestblt;
if (fDDSURFACEDESC2.dwFlags & DDSD_CKDESTOVERLAY) TempFlags_ = TempFlags_ << ddsd_ckdestoverlay;
if (fDDSURFACEDESC2.dwFlags & DDSD_CKSRCBLT) TempFlags_ = TempFlags_ << ddsd_cksrcblt;
if (fDDSURFACEDESC2.dwFlags & DDSD_CKSRCOVERLAY) TempFlags_ = TempFlags_ << ddsd_cksrcoverlay;
if (fDDSURFACEDESC2.dwFlags & DDSD_HEIGHT) TempFlags_ = TempFlags_ << ddsd_height;
if (fDDSURFACEDESC2.dwFlags & DDSD_LINEARSIZE) TempFlags_ = TempFlags_ << ddsd_linearsize;
if (fDDSURFACEDESC2.dwFlags & DDSD_LPSURFACE) TempFlags_ = TempFlags_ << ddsd_lpsurface;
if (fDDSURFACEDESC2.dwFlags & DDSD_MIPMAPCOUNT) TempFlags_ = TempFlags_ << ddsd_mipmapcount;
if (fDDSURFACEDESC2.dwFlags & DDSD_PITCH) TempFlags_ = TempFlags_ << ddsd_pitch;
if (fDDSURFACEDESC2.dwFlags & DDSD_PIXELFORMAT) TempFlags_ = TempFlags_ << ddsd_pixelformat;
if (fDDSURFACEDESC2.dwFlags & DDSD_REFRESHRATE) TempFlags_ = TempFlags_ << ddsd_refreshrate;
if (fDDSURFACEDESC2.dwFlags & DDSD_TEXTURESTAGE) TempFlags_ = TempFlags_ << ddsd_texturestage;
if (fDDSURFACEDESC2.dwFlags & DDSD_WIDTH) TempFlags_ = TempFlags_ << ddsd_width;
return TempFlags_;
}
// --------------------------------------------------------------------------
void __fastcall TDDSurfaceDesc::FSetFlags_( TDDSurfaceDesc_Flags_Set pFlags_ )
{
fDDSURFACEDESC2.dwFlags = 0;
if (pFlags_.Contains(ddsd_alphabitdepth)) fDDSURFACEDESC2.dwFlags |= DDSD_ALPHABITDEPTH;
if (pFlags_.Contains(ddsd_backbuffercount)) fDDSURFACEDESC2.dwFlags |= DDSD_BACKBUFFERCOUNT;
if (pFlags_.Contains(ddsd_caps)) fDDSURFACEDESC2.dwFlags |= DDSD_CAPS;
if (pFlags_.Contains(ddsd_ckdestblt)) fDDSURFACEDESC2.dwFlags |= DDSD_CKDESTBLT;
if (pFlags_.Contains(ddsd_ckdestoverlay)) fDDSURFACEDESC2.dwFlags |= DDSD_CKDESTOVERLAY;
if (pFlags_.Contains(ddsd_cksrcblt)) fDDSURFACEDESC2.dwFlags |= DDSD_CKSRCBLT;
if (pFlags_.Contains(ddsd_cksrcoverlay)) fDDSURFACEDESC2.dwFlags |= DDSD_CKSRCOVERLAY;
if (pFlags_.Contains(ddsd_height)) fDDSURFACEDESC2.dwFlags |= DDSD_HEIGHT;
if (pFlags_.Contains(ddsd_linearsize)) fDDSURFACEDESC2.dwFlags |= DDSD_LINEARSIZE;
if (pFlags_.Contains(ddsd_lpsurface)) fDDSURFACEDESC2.dwFlags |= DDSD_LPSURFACE;
if (pFlags_.Contains(ddsd_mipmapcount)) fDDSURFACEDESC2.dwFlags |= DDSD_MIPMAPCOUNT;
if (pFlags_.Contains(ddsd_pitch)) fDDSURFACEDESC2.dwFlags |= DDSD_PITCH;
if (pFlags_.Contains(ddsd_pixelformat)) fDDSURFACEDESC2.dwFlags |= DDSD_PIXELFORMAT;
if (pFlags_.Contains(ddsd_refreshrate)) fDDSURFACEDESC2.dwFlags |= DDSD_REFRESHRATE;
if (pFlags_.Contains(ddsd_texturestage)) fDDSURFACEDESC2.dwFlags |= DDSD_TEXTURESTAGE;
if (pFlags_.Contains(ddsd_width)) fDDSURFACEDESC2.dwFlags |= DDSD_WIDTH;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDDSurfaceDesc::FGetFlags_Strings()
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDSurfaceDesc::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDDSURFACEDESC2.dwFlags & DDSD_ALPHABITDEPTH) fFlags_Strings->Add("DDSD_ALPHABITDEPTH");
if (fDDSURFACEDESC2.dwFlags & DDSD_BACKBUFFERCOUNT) fFlags_Strings->Add("DDSD_BACKBUFFERCOUNT");
if (fDDSURFACEDESC2.dwFlags & DDSD_CAPS) fFlags_Strings->Add("DDSD_CAPS");
if (fDDSURFACEDESC2.dwFlags & DDSD_CKDESTBLT) fFlags_Strings->Add("DDSD_CKDESTBLT");
if (fDDSURFACEDESC2.dwFlags & DDSD_CKDESTOVERLAY) fFlags_Strings->Add("DDSD_CKDESTOVERLAY");
if (fDDSURFACEDESC2.dwFlags & DDSD_CKSRCBLT) fFlags_Strings->Add("DDSD_CKSRCBLT");
if (fDDSURFACEDESC2.dwFlags & DDSD_CKSRCOVERLAY) fFlags_Strings->Add("DDSD_CKSRCOVERLAY");
if (fDDSURFACEDESC2.dwFlags & DDSD_HEIGHT) fFlags_Strings->Add("DDSD_HEIGHT");
if (fDDSURFACEDESC2.dwFlags & DDSD_LINEARSIZE) fFlags_Strings->Add("DDSD_LINEARSIZE");
if (fDDSURFACEDESC2.dwFlags & DDSD_LPSURFACE) fFlags_Strings->Add("DDSD_LPSURFACE");
if (fDDSURFACEDESC2.dwFlags & DDSD_MIPMAPCOUNT) fFlags_Strings->Add("DDSD_MIPMAPCOUNT");
if (fDDSURFACEDESC2.dwFlags & DDSD_PITCH) fFlags_Strings->Add("DDSD_PITCH");
if (fDDSURFACEDESC2.dwFlags & DDSD_PIXELFORMAT) fFlags_Strings->Add("DDSD_PIXELFORMAT");
if (fDDSURFACEDESC2.dwFlags & DDSD_REFRESHRATE) fFlags_Strings->Add("DDSD_REFRESHRATE");
if (fDDSURFACEDESC2.dwFlags & DDSD_TEXTURESTAGE) fFlags_Strings->Add("DDSD_TEXTURESTAGE");
if (fDDSURFACEDESC2.dwFlags & DDSD_WIDTH) fFlags_Strings->Add("DDSD_WIDTH");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
