// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDDVideoPortConnect.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDDVideoPortConnect 
//               Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDDVideoPortConnect.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDDVideoPortConnect*)
{
    new TDDVideoPortConnect(NULL);
}
// --------------------------------------------------------------------------
namespace Tddvideoportconnect
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDDVideoPortConnect)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDDVideoPortConnect::TDDVideoPortConnect()
// Description: The default constructor for the TDDVideoPortConnect object.
// --------------------------------------------------------------------------
__fastcall TDDVideoPortConnect::TDDVideoPortConnect(TComponent* Owner)
    : TComponent(Owner)
{
fDDVIDEOPORTCONNECT=NULL;
fArraySize=0;
ArraySize=1;
ClearAll();
fFlags_Strings=NULL;
}
// --------------------------------------------------------------------------
// Destructor:  TDDVideoPortConnect::~TDDVideoPortConnect()
// Description: The destructor for the TDDVideoPortConnect object.
// --------------------------------------------------------------------------
__fastcall TDDVideoPortConnect::~TDDVideoPortConnect()
{
// destroy internals
if (ArraySize!=0) ArraySize = 0;
if (fFlags_Strings!=NULL) delete fFlags_Strings;
}
// --------------------------------------------------------------------------
// Property:    ArraySize
// Description: The ArraySize property contains the number of internal 
//              DDVIDEOPORTCONNECT structures wrapped inside the 
//              TDDVideoPortConnect component. 
//              By default the ArraySize is initialized to 1, meaning that 
//              this TDDVideoPortConnect component wraps a single 
//              DDVIDEOPORTCONNECT structure. To wrap multiple structures, 
//              set the TDDVideoPortConnect::ArraySize to the total number of 
//              internal structures desired. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortConnect::FGetArraySize()
{
return fArraySize;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortConnect::FSetArraySize( dword pArraySize )
{
// check for size==0
if (pArraySize==0)
    {
    // de-allocate old memory
    delete[] fDDVIDEOPORTCONNECT;
    fDDVIDEOPORTCONNECT = NULL;
    fArraySize = 0;
    return;
    }

// is anything allocated?
if (fArraySize==0)
    {
    // nope. need to allocate memory for pointers to internal structures
    fDDVIDEOPORTCONNECT = new DDVIDEOPORTCONNECT[pArraySize];
    if (fDDVIDEOPORTCONNECT==NULL)
        {
        fArraySize = 0;
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDVIDEOPORTCONNECT::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DDVIDEOPORTCONNECT structure pointers.");
        return;
        }
    // setup defaults
    fArraySize = pArraySize;
    ClearAll();
    }
else
    // already allocated... has the size increased?
    if (pArraySize>fArraySize)
        {
        // allocate space for the new structures
        DDVIDEOPORTCONNECT* temp_DDVIDEOPORTCONNECT = new DDVIDEOPORTCONNECT[pArraySize];
        if (temp_DDVIDEOPORTCONNECT==NULL)
            {
            fErrorValue = TDX_ERROR;
            if (FOnError) FOnError(this, "TDDVIDEOPORTCONNECT::FSetArraySize()", "TDX_ERROR", "Could not allocate extra memory for storing internal DDVIDEOPORTCONNECT structures.");
            return;
            }
        // clear new data areas
        ZeroMemory( &temp_DDVIDEOPORTCONNECT[fArraySize], sizeof(DDVIDEOPORTCONNECT)*(pArraySize-fArraySize) );
        // duplicate existing data
        CopyMemory( &temp_DDVIDEOPORTCONNECT[0], &fDDVIDEOPORTCONNECT[0], sizeof(DDVIDEOPORTCONNECT)*fArraySize);
        // de-allocate old memory
        delete[] fDDVIDEOPORTCONNECT;
        // re-assign the new memory
        fDDVIDEOPORTCONNECT = temp_DDVIDEOPORTCONNECT;
        // store new array size
        fArraySize = pArraySize;
        }
    else
        // already allocated... has the size reduced?
        if (pArraySize<fArraySize)
            {
            // allocate space for the new structures
            DDVIDEOPORTCONNECT* temp_DDVIDEOPORTCONNECT = new DDVIDEOPORTCONNECT[pArraySize];
            if (temp_DDVIDEOPORTCONNECT==NULL)
                {
                fErrorValue = TDX_ERROR;
                if (FOnError) FOnError(this, "TDDVIDEOPORTCONNECT::FSetArraySize()", "TDX_ERROR", "Could not allocate memory for storing internal DDVIDEOPORTCONNECT structures.");
                return;
                }
            // duplicate existing data
            CopyMemory( &temp_DDVIDEOPORTCONNECT[0], &fDDVIDEOPORTCONNECT[0], sizeof(DDVIDEOPORTCONNECT)*pArraySize);
            // de-allocate the old memory
            delete[] fDDVIDEOPORTCONNECT;
            // re-assign the new memory
            fDDVIDEOPORTCONNECT = temp_DDVIDEOPORTCONNECT;
            // store new array size
            fArraySize = pArraySize;
            }
// else - size is the same.
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDDVideoPortConnect method or 
//              fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDDVideoPortConnect::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortConnect::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Property:    Flags
// Description: The Flags property defines flags indicating the video port 
//              connection's capabilities. 
//              The described effect applies when the flag is set. 
// Flags:       DDVPCONNECT_DISCARDSVREFDATA -
//                The video port will discard any data written during the 
//                VREF period. 
//              DDVPCONNECT_DOUBLECLOCK -
//                Support for double clocking data is available or the video 
//                port should perform double clocking. 
//                This flag is only valid when using an external sync. 
//              DDVPCONNECT_HALFLINE -
//                The video port will write half lines into the frame buffer. 
//                This can sometimes cause the data to be displayed 
//                incorrectly. 
//              DDVPCONNECT_INTERLACED -
//                The video signal is interlaced. 
//                This flag is only used when creating a video port 
//                component. 
//              DDVPCONNECT_INVERTPOLARITY -
//                Support for inverting field polarities is available or the 
//                video port should perform polarity inversion. 
//                This reverses the odd and even fields of a video signal. 
//              DDVPCONNECT_SHAREEVEN -
//                Support for sharing the video port is available and this 
//                video port component will use the even fields for its data. 
//                This flag is only used when creating a video port 
//                component. 
//              DDVPCONNECT_SHAREODD -
//                Support for sharing the video port is available and this 
//                video port component will use the odd fields for its data. 
//                This flag is only used when creating a video port 
//                component. 
//              DDVPCONNECT_VACT -
//                Support for an external VACT signal is available or the 
//                video port should use the external VACT signal. 
//                This flag is only valid when using an external sync. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortConnect::FGetFlags( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FGetFlags()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FGetFlags()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortConnect::FSetFlags( dword pArrayIndex, dword pFlags )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FSetFlags()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FSetFlags()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags = pFlags;
}
// --------------------------------------------------------------------------
// Property:    PortWidth
// Description: The PortWidth property defines the physical pin width of the 
//              video port. 
//              This value does not represent the width of a surface in 
//              memory. 
//              This property must always be set, even when the port type 
//              indicated by TDDVideoPortConnect::TypeID assumes a certain 
//              size. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortConnect::FGetPortWidth( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FGetPortWidth()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FGetPortWidth()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDVIDEOPORTCONNECT[pArrayIndex].dwPortWidth;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortConnect::FSetPortWidth( dword pArrayIndex, dword pPortWidth )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FSetPortWidth()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FSetPortWidth()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDVIDEOPORTCONNECT[pArrayIndex].dwPortWidth = pPortWidth;
}
// --------------------------------------------------------------------------
// Property:    Size
// Description: The Size property defines the size, in bytes, of the internal 
//              structure used by this component. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortConnect::FGetSize( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FGetSize()", "TDX_ERROR", "Internal Array size is 0.");
     return (dword) NULL;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FGetSize()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
     return (dword) NULL;
    }

return fDDVIDEOPORTCONNECT[pArrayIndex].dwSize;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortConnect::FSetSize( dword pArrayIndex, dword pSize )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FSetSize()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FSetSize()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDVIDEOPORTCONNECT[pArrayIndex].dwSize = pSize;
}
// --------------------------------------------------------------------------
// Property:    SizeAll
// Description: The SizeAll property contains the size in bytes of all 
//              internal DDVIDEOPORTCONNECT structures. This result is the 
//              same as multiplying TDDVideoPortConnect::ArraySize and 
//              TDDVideoPortConnect::Size. 
// --------------------------------------------------------------------------
dword __fastcall TDDVideoPortConnect::FGetSizeAll()
{
dword temp = 0;
for (dword i=0;i<fArraySize;i++) temp += fDDVIDEOPORTCONNECT[i].dwSize;
return temp;
}
// --------------------------------------------------------------------------
// Property:    TypeID
// Description: The TypeID property defines GUID's indicating the sync 
//              characteristics of the video port. 
//              Possible values of this property are not limited to those 
//              listed below, they are merely those that are predefined. 
// Flags:       DDVPTYPE_BROOKTREE -
//                The video sync information is embedded in the data stream 
//                using the Brooktree definition. 
//              DDVPTYPE_CCIR656 -
//                The video sync information is embedded in the data stream 
//                according to the CCIR656 specification. 
//              DDVPTYPE_E_HREFH_VREFH -
//                The video sync is provided externally with the HREF 
//                indicated by an active high and the VREF indicated by an 
//                active high. 
//              DDVPTYPE_E_HREFH_VREFL -
//                The video sync is provided externally with the HREF 
//                indicated by an active high and the VREF is indicated by an 
//                active low. 
//              DDVPTYPE_E_HREFL_VREFH -
//                The video sync is provided externally with the HREF 
//                indicated by an active low and the VREF is indicated by an 
//                active high. 
//              DDVPTYPE_E_HREFL_VREFL -
//                The video sync is provided externally with the HREF 
//                indicated by an active low and the VREF is indicated by an 
//                active low. 
//              DDVPTYPE_PHILIPS -
//                The video sync information is embedded in the data stream 
//                using the Philips definition. 
// --------------------------------------------------------------------------
GUID __fastcall TDDVideoPortConnect::FGetTypeID( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FGetTypeID()", "TDX_ERROR", "Internal Array size is 0.");
    return fTypeID;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FGetTypeID()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return fTypeID;
    }

return fDDVIDEOPORTCONNECT[pArrayIndex].guidTypeID;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortConnect::FSetTypeID( dword pArrayIndex, GUID pTypeID )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FSetTypeID()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::FSetTypeID()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

fDDVIDEOPORTCONNECT[pArrayIndex].guidTypeID = pTypeID;
}
// --------------------------------------------------------------------------
// Method:      Clear()
// Description: The Clear() method can be used to clear the contents of the 
//              TDDVideoPortConnect's internal DDVIDEOPORTCONNECT structure. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// Params:      pArrayIndex - 
//                The ArrayIndex parameter determines which internal structure 
//                needs to be cleared. Correct values range from 0 to 
//                TDDVideoPortConnect::ArraySize-1. 
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortConnect::Clear( dword pArrayIndex )
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }
// range check supplied index
if (pArrayIndex>=fArraySize)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::Clear()", "TDX_ERROR", "Supplied index ["+IntToStr(pArrayIndex)+"] is out of bounds [0.."+IntToStr(fArraySize-1)+"]");
    return;
    }

ZeroMemory( &fDDVIDEOPORTCONNECT[pArrayIndex], sizeof(DDVIDEOPORTCONNECT) );
fDDVIDEOPORTCONNECT[pArrayIndex].dwSize = sizeof(DDVIDEOPORTCONNECT);
}


// --------------------------------------------------------------------------
// Method:      ClearAll()
// Description: The ClearAll() method can be used to clear the contents of 
//              all the internal DDVIDEOPORTCONNECT structures of the 
//              TDDVideoPortConnect component. 
//              Note: if you have manually linked a structure member to a 
//              chunk of memory, make sure you release this memory before 
//              calling Clear(). 
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortConnect::ClearAll()
{
// array is allocated?
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, "TDDVideoPortConnect::Clear()", "TDX_ERROR", "Internal Array size is 0.");
    return;
    }

ZeroMemory( &fDDVIDEOPORTCONNECT[0], sizeof(DDVIDEOPORTCONNECT)*fArraySize );
for (dword i=0;i<fArraySize;i++) fDDVIDEOPORTCONNECT[i].dwSize = sizeof(DDVIDEOPORTCONNECT);
}


// --------------------------------------------------------------------------
// Internal Structure Access 
// --------------------------------------------------------------------------
DDVIDEOPORTCONNECT* __fastcall TDDVideoPortConnect::FGetInternal_DDVIDEOPORTCONNECT_Ptr()
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDVideoPortConnect::FGetInternal_DDVIDEOPORTCONNECT_Ptr()", "TDX_ERROR", "Internal Array size is 0." );
    return NULL;
    }
return fDDVIDEOPORTCONNECT;
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortConnect::FSetInternal_DDVIDEOPORTCONNECT( dword pArrayIndex, DDVIDEOPORTCONNECT* pDDVIDEOPORTCONNECT )
{
// check for errors
if (fArraySize==0)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDVideoPortConnect::FSetInternal_DDVIDEOPORTCONNECT()", "TDX_ERROR", "Internal Array size is 0." );
    return;
    }
if (pDDVIDEOPORTCONNECT==NULL)
    {
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError(this, "TDDVideoPortConnect::FSetInternal_DDVIDEOPORTCONNECT()", "TDX_ERROR", "The supplied DDVIDEOPORTCONNECT* was NULL" );
    return;
    }
CopyMemory( &fDDVIDEOPORTCONNECT[pArrayIndex], pDDVIDEOPORTCONNECT, sizeof(DDVIDEOPORTCONNECT) );
Internal_DDVIDEOPORTCONNECT_Update();
}
// --------------------------------------------------------------------------
void __fastcall TDDVideoPortConnect::Internal_DDVIDEOPORTCONNECT_Update()
{
}

// --------------------------------------------------------------------------
// Method:      FGetFlags_
// Description: This method returns a TDDVideoPortConnect_Flags_Set<> of the 
//              flags in the current 
//              fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags. 
// Note:        Multi-Wrapper components do not yet have the capability to 
//              allow modification of flags via the BCB Object Inspector. 
// --------------------------------------------------------------------------
TDDVideoPortConnect_Flags_Set __fastcall TDDVideoPortConnect::FGetFlags_( dword pArrayIndex )
{
TDDVideoPortConnect_Flags_Set TempFlags_;
TempFlags_.Clear();
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_DISCARDSVREFDATA) TempFlags_ = TempFlags_ << ddvpconnect_discardsvrefdata;
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_DOUBLECLOCK) TempFlags_ = TempFlags_ << ddvpconnect_doubleclock;
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_HALFLINE) TempFlags_ = TempFlags_ << ddvpconnect_halfline;
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_INTERLACED) TempFlags_ = TempFlags_ << ddvpconnect_interlaced;
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_INVERTPOLARITY) TempFlags_ = TempFlags_ << ddvpconnect_invertpolarity;
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_SHAREEVEN) TempFlags_ = TempFlags_ << ddvpconnect_shareeven;
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_SHAREODD) TempFlags_ = TempFlags_ << ddvpconnect_shareodd;
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_VACT) TempFlags_ = TempFlags_ << ddvpconnect_vact;
return TempFlags_;
}
// --------------------------------------------------------------------------
// Method:      FGetFlags_Strings()
//              This method creates and then returns a TStringList containing 
//              the current set of 'Flags' flags. 
// Note:        You must manually delete the retrieved TStringList after use 
//              to avoid memory corruption. 
// --------------------------------------------------------------------------
TStringList* __fastcall TDDVideoPortConnect::FGetFlags_Strings( dword pArrayIndex )
{
// if the strings have not been allocated
if (fFlags_Strings==NULL)
    {
    // attempt to allocate the strings
    fFlags_Strings = new TStringList();
    // if the allocation failed
    if (fFlags_Strings==NULL)
        {
        fErrorValue = TDX_ERROR;
        if (FOnError) FOnError(this, "TDDVideoPortConnect::FGetFlags_Strings()", "TDX_ERROR", "Could not allocate memory used to retrieve various Flags_Strings" );
        return NULL;
        }
    }
fFlags_Strings->Clear();
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_DISCARDSVREFDATA) fFlags_Strings->Add("DDVPCONNECT_DISCARDSVREFDATA");
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_DOUBLECLOCK) fFlags_Strings->Add("DDVPCONNECT_DOUBLECLOCK");
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_HALFLINE) fFlags_Strings->Add("DDVPCONNECT_HALFLINE");
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_INTERLACED) fFlags_Strings->Add("DDVPCONNECT_INTERLACED");
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_INVERTPOLARITY) fFlags_Strings->Add("DDVPCONNECT_INVERTPOLARITY");
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_SHAREEVEN) fFlags_Strings->Add("DDVPCONNECT_SHAREEVEN");
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_SHAREODD) fFlags_Strings->Add("DDVPCONNECT_SHAREODD");
if (fDDVIDEOPORTCONNECT[pArrayIndex].dwFlags & DDVPCONNECT_VACT) fFlags_Strings->Add("DDVPCONNECT_VACT");
return fFlags_Strings;
}
// --------------------------------------------------------------------------
