// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDx_DrawGammaControl.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDx_DrawGammaControl 
//               Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDx_DrawGammaControl.H"
// --------------------------------------------------------------------------
// external classes used by the TDx_DrawGammaControl component.
#include "TDx_Draw.H"
// --------------------------------------------------------------------------
// external classes used by TDx_DrawGammaControl methods.
#include "TDDGammaRamp.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDx_DrawGammaControl*)
{
    new TDx_DrawGammaControl(NULL);
}
// --------------------------------------------------------------------------
namespace Tdx_drawgammacontrol
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDx_DrawGammaControl)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDx_DrawGammaControl::TDx_DrawGammaControl()
// Description: The default constructor for the TDx_DrawGammaControl object.
// --------------------------------------------------------------------------
__fastcall TDx_DrawGammaControl::TDx_DrawGammaControl(TComponent* Owner)
    : TComponent(Owner)
{
fCreated = false;
fErrorValue = D3D_OK;
}
// --------------------------------------------------------------------------
// Destructor:  TDx_DrawGammaControl::~TDx_DrawGammaControl()
// Description: The destructor for the TDx_DrawGammaControl object.
// --------------------------------------------------------------------------
__fastcall TDx_DrawGammaControl::~TDx_DrawGammaControl()
{
// destroy internals
if (Created) Destroy();
}
// --------------------------------------------------------------------------
// Property:    Created
// Description: The Created property is true if the internal 
//              LPDIRECTDRAWGAMMACONTROL used in this component has been 
//              successfully created, otherwise Created is false. 
//              
//              To create the internal LPDIRECTDRAWGAMMACONTROL, call the 
//              TDx_DrawGammaControl::Create() method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawGammaControl::FGetCreated()
{
return fCreated;
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawGammaControl::FSetCreated( bool pCreated )
{
fCreated = (pCreated && (fLPDIRECTDRAWGAMMACONTROL==NULL));
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDx_DrawGammaControl method or 
//              fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDx_DrawGammaControl::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawGammaControl::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Method:      Create()
// Description: The Create() method is used to automatically create the 
//              internal LPDIRECTDRAWGAMMACONTROL interface used in the 
//              TDx_DrawGammaControl component and must be called before any 
//              methods of the TDx_DrawGammaControl component will function. 
// Params:      pDraw - 
//                The TDx_Draw object that will manage the created 
//                GammaControl. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawGammaControl::Create( TDx_Draw* pDraw )
{
// if the component internals have already been created, exit
if (fCreated)
    {
    fErrorValue = TDX_ALREADYCREATED;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ALREADYCREATED", "The "+Name+"::Create() method was called when the component has already been created successfully." );
    return false;
    }

// check params for accuracy
if (pDraw==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_BADPARAMS", "The 'pDraw' parameter must point to an existing TDx_Draw component and cannot be NULL." );
    return false;
    }

// code that creates the internal interface
fErrorValue = pDraw->Internal_LPDIRECTDRAW7->QueryInterface( IID_IDirectDrawGammaControl, (LPVOID*) &fLPDIRECTDRAWGAMMACONTROL);

// check for error result
if (fErrorValue!=DD_OK)
    {
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", Name+"::Create() failed with Error: "+TDx_Draw_Library_ErrorString(fErrorValue)+", "+TDx_Draw_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// successfully created
fCreated = true;
if (FOnCreate) FOnCreate(this);
return true;
}

// --------------------------------------------------------------------------
// Method:      Destroy()
// Description: The Destroy() method is used to automatically destroy the 
//              internal LPDIRECTDRAWGAMMACONTROL interface used in the 
//              TDx_DrawGammaControl component and should be called when the 
//              internal interface is no longer required. 
//              
//              Note: This method is called by the component's destructor. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawGammaControl::Destroy()
{
// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_NOTCREATED", "The "+Name+"::Destroy() method was called before being created successfully." );
    return false;
    }

// code that destroys the internal interfaces
if (FOnDestroy) FOnDestroy(this);

if (fLPDIRECTDRAWGAMMACONTROL==NULL) 
    { 
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "The "+Name+" component's internal LPDIRECTDRAWGAMMACONTROL is NULL. Aborting the Destroy()." );
    return false;
    }

try { 
    fLPDIRECTDRAWGAMMACONTROL->Release(); 
    } 
catch (...) 
    { 
    fErrorValue = TDX_ERROR; 
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "An exception occurred in LPDIRECTDRAWGAMMACONTROL->Release(). Check you are destroying all components in reverse order of creation." );
    }

// successful destruction
fLPDIRECTDRAWGAMMACONTROL = NULL;
fCreated = false;
return true;
}

// --------------------------------------------------------------------------
// Method:      GetGammaRamp()
// Description: The TDx_DrawGammaControl::GetGammaRamp method will retrieve 
//              the gamma information from a primary surface. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DDERR_EXCEPTION 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
// Params:      pRampData - 
//                The RampData parameter references a TDDGammaRamp component 
//                for holding the retrieved gamma information if this method 
//                returns successfully. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawGammaControl::GetGammaRamp( TDDGammaRamp* pRampData )
{
// Original Function Definition
// HRESULT GetGammaRamp( 
//   DWORD  dwFlags, 
//   LPDDGAMMARAMP lpRampData 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetGammaRamp()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pRampData==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetGammaRamp()", "TDX_BADPARAMS", "'pRampData' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTDRAWGAMMACONTROL->GetGammaRamp( 0, pRampData->Internal_DDGAMMARAMP_Ptr );

// Translate Data returned from Function
pRampData->Internal_DDGAMMARAMP_Update();

// Handle any Known Results
if (fErrorValue!=DD_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetGammaRamp()", TDx_Draw3D_Library_ErrorString(fErrorValue), TDx_Draw3D_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      SetGammaRamp()
// Description: The TDx_DrawGammaControl::SetGammaRamp method will set the 
//              gamma information of the primary surface to the specified 
//              values. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DDERR_EXCEPTION 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
//              DDERR_OUTOFMEMORY 
// Params:      pFlags - 
//                The Flags parameter defines a flag indicating whether gamma 
//                calibration should be used. 
//                The described effect applies when the flag is set. 
//                Flags:
//                  DDSGR_CALIBRATE -
//                    Adjust the gamma settings to suit the physical display 
//                    so that different systems will display the same result. 
//                     Hardware support for gamma calibration must exist when 
//                    using this flag. Support can be checked by using the 
//                    TDx_Draw::GetCaps() method and checking the Caps2 
//                    property for the DDCAPS2_PRIMARYGAMMA flag. 
//              pRampData - 
//                The RampData parameter references a TDDGammaRamp component 
//                holding the new gamma values to be set for the primary 
//                surface. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawGammaControl::SetGammaRamp( dword pFlags, TDDGammaRamp* pRampData )
{
// Original Function Definition
// HRESULT SetGammaRamp( 
//   DWORD  dwFlags, 
//   LPDDGAMMARAMP lpRampData 
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetGammaRamp()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pRampData==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::SetGammaRamp()", "TDX_BADPARAMS", "'pRampData' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTDRAWGAMMACONTROL->SetGammaRamp( (DWORD) pFlags, pRampData->Internal_DDGAMMARAMP_Ptr );

// Translate Data returned from Function
pRampData->Internal_DDGAMMARAMP_Update();

// Handle any Known Results
if (fErrorValue!=DD_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetGammaRamp()", TDx_Draw3D_Library_ErrorString(fErrorValue), TDx_Draw3D_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Internal Interface Access
// --------------------------------------------------------------------------
LPDIRECTDRAWGAMMACONTROL __fastcall TDx_DrawGammaControl::FGetInternal_LPDIRECTDRAWGAMMACONTROL()
{
return fLPDIRECTDRAWGAMMACONTROL;
}
// --------------------------------------------------------------------------
LPDIRECTDRAWGAMMACONTROL* __fastcall TDx_DrawGammaControl::FGetInternal_LPDIRECTDRAWGAMMACONTROL_Ptr()
{
return &fLPDIRECTDRAWGAMMACONTROL;
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawGammaControl::FSetInternal_LPDIRECTDRAWGAMMACONTROL( LPDIRECTDRAWGAMMACONTROL pLPDIRECTDRAWGAMMACONTROL )
{
if (!fCreated)
    {
    fLPDIRECTDRAWGAMMACONTROL = pLPDIRECTDRAWGAMMACONTROL;
    fCreated = (fLPDIRECTDRAWGAMMACONTROL!=NULL);
    }
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawGammaControl::Internal_LPDIRECTDRAWGAMMACONTROL_Update()
{
fCreated = (fLPDIRECTDRAWGAMMACONTROL!=NULL);
}

// --------------------------------------------------------------------------
