// --------------------------------------------------------------------------

// ==========================================================================
// File:         TDx_DrawPalette.CPP
// Authors:      BCB_Code_Generator v1.70,
//               Darren Dwyer (source code, documentation, demos, website),
//               Hugh Edwards (documentation, icons)
// Description:  This file contains the code for the TDx_DrawPalette 
//               Component 
//
// "TDx_Draw3D_Library v1.70"
// (c) 2003 BCB-Tools.com Pty. Ltd., Sydney, Australia.
// All Rights Reserved.
//
// Refer to the 'Licence.Txt' file for licencing & copyright information.
// ==========================================================================

// --------------------------------------------------------------------------
// #includes ...
// --------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
// --------------------------------------------------------------------------
#include "TDx_DrawPalette.H"
// --------------------------------------------------------------------------
// external classes used by the TDx_DrawPalette component.
#include "TDx_Draw.H"
// --------------------------------------------------------------------------
#pragma link "TDx_Library_Defns"
#pragma link "TDx_Library_Functions"
#pragma link "TDx_Draw3D_Library_Defns"
#pragma link "TDx_Draw3D_Library_Functions"

// --------------------------------------------------------------------------
// Object Registration...
// --------------------------------------------------------------------------
#if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    #pragma package(smart_init)
#endif
// --------------------------------------------------------------------------
static inline void ValidCtrCheck(TDx_DrawPalette*)
{
    new TDx_DrawPalette(NULL);
}
// --------------------------------------------------------------------------
namespace Tdx_drawpalette
{
    #if (__BORLANDC__ >= 0x0530) // BCB Version 3+
    void __fastcall PACKAGE Register()
    #else
    void __fastcall Register()
    #endif
    {
        TComponentClass classes[1] = {__classid(TDx_DrawPalette)};
        RegisterComponents("TDx_Draw3D", classes, 0);
    }
}

// --------------------------------------------------------------------------
// Constructor: TDx_DrawPalette::TDx_DrawPalette()
// Description: The default constructor for the TDx_DrawPalette object.
// --------------------------------------------------------------------------
__fastcall TDx_DrawPalette::TDx_DrawPalette(TComponent* Owner)
    : TComponent(Owner)
{
fCreated = false;
fErrorValue = D3D_OK;
}
// --------------------------------------------------------------------------
// Destructor:  TDx_DrawPalette::~TDx_DrawPalette()
// Description: The destructor for the TDx_DrawPalette object.
// --------------------------------------------------------------------------
__fastcall TDx_DrawPalette::~TDx_DrawPalette()
{
// destroy internals
if (Created) Destroy();
}
// --------------------------------------------------------------------------
// Property:    Created
// Description: The Created property is true if the internal 
//              LPDIRECTDRAWPALETTE used in this component has been 
//              successfully created, otherwise Created is false. 
//              
//              To create the internal LPDIRECTDRAWPALETTE, call the 
//              TDx_DrawPalette::Create() method. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawPalette::FGetCreated()
{
return fCreated;
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawPalette::FSetCreated( bool pCreated )
{
fCreated = (pCreated && (fLPDIRECTDRAWPALETTE==NULL));
}
// --------------------------------------------------------------------------
// Property:    ErrorValue
// Description: The ErrorValue property contains the last error value 
//              returned from a call to a TDx_DrawPalette method or 
//              fget/fset. eg. D3D_OK or DDERR_SURFACELOST or TDX_ERROR 
// --------------------------------------------------------------------------
HRESULT __fastcall TDx_DrawPalette::FGetErrorValue()
{
return fErrorValue;
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawPalette::FSetErrorValue( HRESULT pErrorValue )
{
fErrorValue = pErrorValue;
}
// --------------------------------------------------------------------------
// Method:      Create()
// Description: The Create() method is used to automatically create the 
//              internal LPDIRECTDRAWPALETTE interface used in the 
//              TDx_DrawPalette component and must be called before any 
//              methods of the TDx_DrawPalette component will function. 
// Params:      pFlags - 
//                Flags describing the created palette. 
//                Flags:
//                  DDPCAPS_1BIT -
//                    The DDPCAPS_1BIT Flag indicates the index is one bit. 
//                    ie, there are two entrys in the palette. 
//                  DDPCAPS_2BIT -
//                    The DDPCAPS_2BIT Flag indicates the index is two bits. 
//                    ie, there are four entrys in the palette. 
//                  DDPCAPS_4BIT -
//                    The DDPCAPS_4BIT Flag indicates the index is four bits. 
//                    ie, there are sixteen entrys in the palette. 
//                  DDPCAPS_8BIT -
//                    The DDPCAPS_4BIT Flag indicates the index is eight 
//                    bits. ie, there are 256 entrys in the palette. 
//                  DDPCAPS_8BITENTRIES -
//                    This flag indicates the index refers to an 8 bit color 
//                    index. Valid only with the DDPCAPS_1BIT, DDPCAPS_2BIT, 
//                    or DDPCAPS_4BIT flags, when the target surface is 8 
//                    bpp.   
//                    
//                    Each color entry is one byte long and is an index to a 
//                    destination surfaces 8-bpp palette. 
//                  DDPCAPS_ALLOW256 -
//                    All 256 palette entries can be defined. 
//                  DDPCAPS_ALPHA -
//                    Used with 'texture' surfaces, this flag indicates the 
//                    Flags member of the PALETTEENTRY structure is 
//                    interpreted as a single 8 bit alpha value. 
//                  DDPCAPS_INITIALIZE -
//                    The created palette is to be initialized with the 
//                    colors described in the ColorArray parameter. 
//                  DDPCAPS_PRIMARYSURFACE -
//                    The palette is for the primary surface, any changes 
//                    will be immediatly visible on the display, unless 
//                    DDPSETPAL_VSYNC is specified and supported. 
//                  DDPCAPS_PRIMARYSURFACELEFT -
//                    The palette is for the left eye primary surface, any 
//                    changes will be immediatly visible on the left eye 
//                    display, unless DDPSETPAL_VSYNC is specified and 
//                    supported. 
//                  DDPCAPS_VSYNC -
//                    The palette can have modifications synchronised to the 
//                    monitors refresh rate. 
//              pColorArray - 
//                An array of 2, 4, 16, or 256 PALETTEENTRY structures that 
//                will initialize this DirectDrawPalette object 
//              pDraw - 
//                A TDx_Draw object that is responsible for the created palette 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawPalette::Create( dword pFlags, PALETTEENTRY* pColorArray, TDx_Draw* pDraw )
{
// if the component internals have already been created, exit
if (fCreated)
    {
    fErrorValue = TDX_ALREADYCREATED;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ALREADYCREATED", "The "+Name+"::Create() method was called when the component has already been created successfully." );
    return false;
    }

// check params for accuracy
if (pColorArray==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_BADPARAMS", "The 'pColorArray' parameter must point to an existing array of DDPALETTEENTRY structures and cannot be NULL." );
    return false;
    }
if (pDraw==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_BADPARAMS", "The 'pDraw' parameter must point to an existing TDx_Draw component and cannot be NULL." );
    return false;
    }

// code that creates the internal IDirectDrawPalette interface
pDraw->CreatePalette( pFlags, pColorArray, this );
fErrorValue = pDraw->ErrorValue;

// check for error result
if (fErrorValue!=DD_OK)
    {
    if (FOnError) FOnError( this, Name+"::Create()", "TDX_ERROR", Name+"::Create() failed with Error: "+TDx_Draw_Library_ErrorString(fErrorValue)+", "+TDx_Draw_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// successfully created
fCreated = true;
if (FOnCreate) FOnCreate(this);
return true;
}

// --------------------------------------------------------------------------
// Method:      Destroy()
// Description: The Destroy() method is used to automatically destroy the 
//              internal LPDIRECTDRAWPALETTE interface used in the 
//              TDx_DrawPalette component and should be called when the 
//              internal interface is no longer required. 
//              
//              Note: This method is called by the component's destructor. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawPalette::Destroy()
{
// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_NOTCREATED", "The "+Name+"::Destroy() method was called before being created successfully." );
    return false;
    }

// code that destroys the internal interfaces
if (FOnDestroy) FOnDestroy(this);

if (fLPDIRECTDRAWPALETTE==NULL) 
    { 
    fErrorValue = TDX_ERROR;
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "The "+Name+" component's internal LPDIRECTDRAWPALETTE is NULL. Aborting the Destroy()." );
    return false;
    }

try { 
    fLPDIRECTDRAWPALETTE->Release(); 
    } 
catch (...) 
    { 
    fErrorValue = TDX_ERROR; 
    if (FOnError) FOnError( this, Name+"::Destroy()", "TDX_ERROR", "An exception occurred in LPDIRECTDRAWPALETTE->Release(). Check you are destroying all components in reverse order of creation." );
    }

// successful destruction
fLPDIRECTDRAWPALETTE = NULL;
fCreated = false;
return true;
}

// --------------------------------------------------------------------------
// Method:      GetCaps()
// Description: The TDx_DrawPalette::GetCaps method will return the palette 
//              capabilities. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
// Params:      pCaps - 
//                The Caps parameter will reference the palette capabilities if 
//                this method returns successfully. 
//                The described effect applies when the flag is set. 
//                These flags are the same as those listed for 
//                TDDCaps::PalCaps. 
//                Flags:
//                  DDPCAPS_1BIT -
//                    The palette index is 1 bit. 
//                    There will be 2 color table entries. 
//                  DDPCAPS_2BIT -
//                    The palette index is 2 bit. 
//                    There will be 4 color table entries. 
//                  DDPCAPS_4BIT -
//                    The palette index is 4 bit. 
//                    There will be 16 color table entries. 
//                  DDPCAPS_8BIT -
//                    The palette index is 8 bit. 
//                    There will be 256 color table entries. 
//                  DDPCAPS_8BITENTRIES -
//                    The palette index is an index to a 8-bit color index. 
//                    This flag is only valid when the target surface is 8 
//                    bpp and either  DDPCAPS_1BIT, DDPCAPS_2BIT or 
//                    DDPCAPS_4BIT is set. Color entries are 8 bits and are 
//                    indexes into the 8 bpp palette of the destination 
//                    surface. 
//                  DDPCAPS_ALLOW256 -
//                    The palette can have all 256 entries specified by the 
//                    application. 
//                    Entry 0 and entry 255 on 8-bit palettes are reserved 
//                    for system use unless this flag is set. 
//                  DDPCAPS_ALPHA -
//                    The peFlags member of the associated PALETTEENTRY 
//                    structure is to be interpreted as an 8-bit alpha value. 
//                    Palettes utilizing this capability may only be attached 
//                    to textures. 
//                  DDPCAPS_PRIMARYSURFACE -
//                    The palette is attached to the primary surface. 
//                    Changes to the palette will be immediately apparent on 
//                    the display unless DDPCAPS_VSYNC is set and supported. 
//                  DDPCAPS_PRIMARYSURFACELEFT -
//                    The palette is attached to the primary surface for the 
//                    left eye. 
//                    Changes to the palette will have an immediate effect on 
//                    the left eye display unless DDPCAPS_VSYNC is set and 
//                    supported. 
//                  DDPCAPS_VSYNC -
//                    The palette is capable of being modified synchronously 
//                    with the monitor's refresh rate. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawPalette::GetCaps( dword* pCaps )
{
// Original Function Definition
// HRESULT GetCaps( 
//   LPDWORD lpdwCaps   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetCaps()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pCaps==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetCaps()", "TDX_BADPARAMS", "'pCaps' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTDRAWPALETTE->GetCaps( (LPDWORD) pCaps );

// Handle any Known Results
if (fErrorValue!=DD_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetCaps()", TDx_Draw3D_Library_ErrorString(fErrorValue), TDx_Draw3D_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      GetEntries()
// Description: The TDx_DrawPalette::GetEntries method will retrieve 
//              specified color table entries from the palette. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
//              DDERR_NOTPALETTIZED 
// Params:      pBase - 
//                The Base parameter defines the start of the entries to be 
//                retrieved sequentially. 
//              pNumEntries - 
//                The NumEntries parameter defines the number of entries the 
//                Entries parameter of this method can hold. 
//              pEntries - 
//                The Entries parameter will reference the array of retrieved 
//                PALETTEENTRY 's if this method returns successfully. 
//                Palette entries will be 4 bytes each unless 
//                DDPCAPS_8BITENTRIES is set, in which case each entry will be 
//                1 byte. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawPalette::GetEntries( dword pBase, dword pNumEntries, PALETTEENTRY* pEntries )
{
// Original Function Definition
// HRESULT GetEntries( 
//   DWORD dwFlags,             
//   DWORD dwBase,             
//   DWORD dwNumEntries,       
//   LPPALETTEENTRY lpEntries   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::GetEntries()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pEntries==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::GetEntries()", "TDX_BADPARAMS", "'pEntries' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTDRAWPALETTE->GetEntries( 0, (DWORD) pBase, (DWORD) pNumEntries, (LPPALETTEENTRY) pEntries );

// Handle any Known Results
if (fErrorValue!=DD_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::GetEntries()", TDx_Draw3D_Library_ErrorString(fErrorValue), TDx_Draw3D_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Method:      LoadFromFile()
// Description: The LoadFromFile method is used to load a 256-color palette 
//              from an existing .BMP image file. 
// Params:      pDraw - 
//                The Draw parameter must be a previously created TDx_Draw 
//                component. 
//              pFileName - 
//                The FileName parameter specifies the name of a standard .BMP 
//                file that the palette is to be loaded from and can include a 
//                directory path if required. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawPalette::LoadFromFile( TDx_Draw* pDraw, AnsiString pFileName )
{
// check params for accuracy
if (pDraw==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::LoadFromFile()", "TDX_BADPARAMS", "The 'pDraw' parameter must point to an existing TDx_Draw component and cannot be NULL." );
    return false;
    }
if (pFileName=="") 
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::LoadFromFile()", "TDX_BADPARAMS", "The 'pFileName' parameter cannot be a null string." );
    return false;
    }

// temporary storage for a 8-bit 256 color palette
int i;
PALETTEENTRY palette_entries[256];

// attempt to open an existing palette file.
// if the file cannot be opened for any reason, build a default palette.
 
int file_handle = _lopen( pFileName.c_str(), OF_READ);
if (file_handle != -1)
    {
    BITMAPFILEHEADER        bitmap_header;
    BITMAPINFOHEADER        bitmap_info;

    _lread(file_handle, &bitmap_header, sizeof(bitmap_header));
    _lread(file_handle, &bitmap_info, sizeof(bitmap_info));
    _lread(file_handle, palette_entries, sizeof(palette_entries));

    _lclose(file_handle);

    // convert colors from BGR to RGB
    int n;    
    if (bitmap_info.biSize != sizeof(BITMAPINFOHEADER)) n = 0;
    else if (bitmap_info.biBitCount > 8) n = 0;
    else if (bitmap_info.biClrUsed == 0) n = 1 << bitmap_info.biBitCount;
    else n = bitmap_info.biClrUsed;
    for (i=0;i<n;i++)
        {
        BYTE red = palette_entries[i].peRed;
        palette_entries[i].peRed = palette_entries[i].peBlue;
        palette_entries[i].peBlue = red;
        }
 
    // pad out the known palette to a 256-color palette
    for (i=n;i<256;i++)
        {
        palette_entries[i].peRed = (BYTE) (((i >> 5) & 0x07) * 255 / 7);
        palette_entries[i].peGreen = (BYTE) (((i >> 2) & 0x07) * 255 / 7);
        palette_entries[i].peBlue = (BYTE) (((i >> 0) & 0x03) * 255 / 3);
        palette_entries[i].peFlags = (BYTE) 0;
        }
    }
else
    {
    // Build the default palette.
    for (i=0;i<256;i++)
        {
        palette_entries[i].peRed = (BYTE) (((i >> 5) & 0x07) * 255 / 7);
        palette_entries[i].peGreen = (BYTE) (((i >> 2) & 0x07) * 255 / 7);
        palette_entries[i].peBlue = (BYTE) (((i >> 0) & 0x03) * 255 / 3);
        palette_entries[i].peFlags = (BYTE) 0;
        }
    }

// recreate internals to use the new palette
if (Created) Destroy();
return Create( DDPCAPS_8BIT, palette_entries, pDraw );
}

// --------------------------------------------------------------------------
// Method:      LoadFromResource()
// Description: The LoadFromResource method is used to load a 256-color 
//              palette from an existing bitmap resource. 
// Params:      pDraw - 
//                The Draw parameter must be a previously created TDx_Draw 
//                component. 
//              pResourceName - 
//                The ResourceName parameter specifies the name of a standard 
//                bitmap source that the palette is to be loaded from. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawPalette::LoadFromResource( TDx_Draw* pDraw, AnsiString pResourceName )
{
// check params for accuracy
if (pDraw==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::LoadFromResource()", "TDX_BADPARAMS", "The 'pDraw' parameter must point to an existing TDx_Draw component and cannot be NULL." );
    return false;
    }
if (pResourceName=="")
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::LoadFromResource()", "TDX_BADPARAMS", "The 'pResourceName' parameter cannot be a null string." );
    return false;
    }

// temporary storage for a 8-bit 256 color palette, etc.
int                     i;
PALETTEENTRY            palette_entries[256];
LPBITMAPINFOHEADER      bitmap_info_header;
RGBQUAD*                rgb_quad;

// attempt to open an existing bitmap resource.
// if the resource cannot be opened for any reason, build a default palette.
 
HRSRC resource = FindResource(NULL, pResourceName.c_str(), RT_BITMAP);
if (resource)
    {
    bitmap_info_header = (LPBITMAPINFOHEADER) LockResource(LoadResource(NULL, resource));
    if (!bitmap_info_header) return false;

    rgb_quad = (RGBQUAD*) ((BYTE*) bitmap_info_header + bitmap_info_header->biSize);

    //  convert colors from BGR to RGB.
    int n;
    if (bitmap_info_header == NULL || bitmap_info_header->biSize < sizeof(BITMAPINFOHEADER)) n = 0;
    else if (bitmap_info_header->biBitCount > 8) n = 0;
    else if (bitmap_info_header->biClrUsed == 0) n = 1 << bitmap_info_header->biBitCount;
    else n = bitmap_info_header->biClrUsed;
    
    for (i=0;i<n;i++)
        {
        palette_entries[i].peRed = rgb_quad[i].rgbRed;
        palette_entries[i].peGreen = rgb_quad[i].rgbGreen;
        palette_entries[i].peBlue = rgb_quad[i].rgbBlue;
        palette_entries[i].peFlags = 0;
        }
    
    // pad out the known palette to a 256-color palette
    for (i=n;i<256;i++)
        {
        palette_entries[i].peRed = (BYTE) (((i >> 5) & 0x07) * 255 / 7);
        palette_entries[i].peGreen = (BYTE) (((i >> 2) & 0x07) * 255 / 7);
        palette_entries[i].peBlue = (BYTE) (((i >> 0) & 0x03) * 255 / 3);
        palette_entries[i].peFlags = (BYTE) 0;
        }
    }
else
    {
    // Build the default palette.
    for (i=0;i<256;i++)
        {
        palette_entries[i].peRed = (BYTE) (((i >> 5) & 0x07) * 255 / 7);
        palette_entries[i].peGreen = (BYTE) (((i >> 2) & 0x07) * 255 / 7);
        palette_entries[i].peBlue = (BYTE) (((i >> 0) & 0x03) * 255 / 3);
        palette_entries[i].peFlags = (BYTE) 0;
        }
    }

// recreate internals to use the new palette
if (Created) Destroy();
return Create( DDPCAPS_8BIT, palette_entries, pDraw );
}

// --------------------------------------------------------------------------
// Method:      SetEntries()
// Description: The TDx_DrawPalette::SetEntries method will change the color 
//              entries in a palette. 
//              
//              If the method call fails, the OnError event will be triggered 
//              with one of the following values: 
//              DDERR_INVALIDOBJECT 
//              DDERR_INVALIDPARAMS 
//              DDERR_NOPALETTEATTACHED 
//              DDERR_NOTPALETTIZED 
//              DDERR_UNSUPPORTED 
// Params:      pStartingEntry - 
//                The StartingEntry parameter defines the palette index of the 
//                first entry to be set. 
//              pCount - 
//                The Count parameter defines the number of palette entries to 
//                be set. 
//              pEntries - 
//                The Entries parameter references the PALETTEENTRY 's that are 
//                to replace those being changed. 
//                Palette entries will be 4 bytes each unless 
//                DDPCAPS_8BITENTRIES is set, in which case each entry will be 
//                1 byte. 
// --------------------------------------------------------------------------
bool __fastcall TDx_DrawPalette::SetEntries( dword pStartingEntry, dword pCount, PALETTEENTRY* pEntries )
{
// Original Function Definition
// HRESULT SetEntries( 
//   DWORD dwFlags,           
//   DWORD dwStartingEntry,   
//   DWORD dwCount,           
//   LPPALETTEENTRY lpEntries   
// ); 

// if the component internals are not already created, exit
if (!fCreated)
    {
    fErrorValue = TDX_NOTCREATED;
    if (FOnError) FOnError( this, Name+"::SetEntries()", "TDX_NOTCREATED", "The "+Name+" component has not been created successfully." );
    return false;
    }

// Check Parameters for Accuracy
if (pEntries==NULL)
    {
    fErrorValue = TDX_BADPARAMS;
    if (FOnError) FOnError( this, Name+"::SetEntries()", "TDX_BADPARAMS", "'pEntries' cannot be 'NULL'");
    return false;
    }

// Call Original Function
fErrorValue = fLPDIRECTDRAWPALETTE->SetEntries( 0, (DWORD) pStartingEntry, (DWORD) pCount, (LPPALETTEENTRY) pEntries );

// Handle any Known Results
if (fErrorValue!=DD_OK)
    {
    // Failure.
    if (FOnError) FOnError( this, Name+"::SetEntries()", TDx_Draw3D_Library_ErrorString(fErrorValue), TDx_Draw3D_Library_ErrorMessage(fErrorValue) );
    return false;
    }

// Success!
return true;
}


// --------------------------------------------------------------------------
// Internal Interface Access
// --------------------------------------------------------------------------
LPDIRECTDRAWPALETTE __fastcall TDx_DrawPalette::FGetInternal_LPDIRECTDRAWPALETTE()
{
return fLPDIRECTDRAWPALETTE;
}
// --------------------------------------------------------------------------
LPDIRECTDRAWPALETTE* __fastcall TDx_DrawPalette::FGetInternal_LPDIRECTDRAWPALETTE_Ptr()
{
return &fLPDIRECTDRAWPALETTE;
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawPalette::FSetInternal_LPDIRECTDRAWPALETTE( LPDIRECTDRAWPALETTE pLPDIRECTDRAWPALETTE )
{
if (!fCreated)
    {
    fLPDIRECTDRAWPALETTE = pLPDIRECTDRAWPALETTE;
    fCreated = (fLPDIRECTDRAWPALETTE!=NULL);
    }
}
// --------------------------------------------------------------------------
void __fastcall TDx_DrawPalette::Internal_LPDIRECTDRAWPALETTE_Update()
{
fCreated = (fLPDIRECTDRAWPALETTE!=NULL);
}

// --------------------------------------------------------------------------
